VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Class1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private Declare Function mciSendCommand Lib "winmm.dll" _
                                Alias "mciSendCommandA" _
                                (ByVal wDeviceID As Long, _
                                ByVal uMessage As Long, _
                                ByVal dwParam1 As Long, _
                                dwParam2 As Any) _
                                As Long
                                
                                
Private Declare Function mciGetErrorString Lib "winmm.dll" Alias "mciGetErrorStringA" ( _
    ByVal dwError As Long, _
    ByVal lpstrBuffer As String, _
    ByVal uLength As Long) As Long
                                
                                
Private Type MCI_OPEN_PARMS
    dwCallback                  As Long
    wDeviceID                   As Long
    lpstrDeviceType             As String
    lpstrElementName            As String
    lpstrAlias                  As String
End Type

Private Type MCI_GENERIC_PARMS
    dwCallback                  As Long
End Type

Private Type MCI_SET_PARMS
    dwCallback                  As Long
    dwTimeFormat                As Long
    dwAudio                     As Long
End Type

Private Type MCI_PLAY_PARMS
    dwCallback                  As Long
    dwFrom                      As Long
    dwTo                        As Long
End Type

Private Type MCI_STATUS_PARMS
    dwCallback                  As Long
    dwReturn                    As Long
    dwItem                      As Long
    dwTrack                     As Integer
End Type

Private Const MCI_PAUSE As Long = &H809
Private Const MCI_CLOSE = &H804
Private Const MCI_WAIT = &H2&
Private Const MCI_OPEN = &H803
Private Const MCI_FORMAT_MILLISECONDS = 0
Private Const MCI_SET = &H80D
Private Const MCI_OPEN_ELEMENT = &H200&
Private Const MCI_SET_TIME_FORMAT = &H400&
Private Const MCI_STOP = &H808
Private Const MCI_SEEK = &H807
Private Const MCI_SEEK_TO_START = &H100&
Private Const MCI_PLAY = &H806
Private Const MCI_NOTIFY = &H1&
Private Const MCI_STATUS_POSITION = &H2&
Private Const MCI_STATUS = &H814
Private Const MCI_STATUS_ITEM = &H100&
Private Const MCI_OPEN_SHAREABLE = &H100&
Private Const MCI_OPEN_TYPE = &H2000&
Private Const MCI_SET_DOOR_OPEN = &H100&
Private Const MCI_FORMAT_TMSF = 10
Private Const MCI_STATUS_LENGTH = &H1&
Private Const MCI_TRACK = &H10&
Private Const MCI_TO = &H8
Private Const MCI_FROM = &H4

Private cTrackCollection    As Collection
Private mciOpenParameter    As MCI_OPEN_PARMS
Private Const MCI_TRACK_NUMBERSTATE = &H3&
Private Const iLenErrString As Integer = 100
Private blPlay              As Boolean

Private Sub Class_Initialize()
    On Error GoTo ErrHandle
    mciOpenParameter.dwCallback = 0
    mciOpenParameter.wDeviceID = 0
    mciOpenParameter.lpstrDeviceType = "cdaudio"
    mciOpenParameter.lpstrElementName = 0
    mciOpenParameter.lpstrAlias = 0
ErrExit:
  Exit Sub
ErrHandle:
  MsgBox "Error : " & Err.Number & ". " & Err.Description
  Resume ErrExit
End Sub

Private Sub Class_Terminate()
    On Error GoTo ErrHandle
    CloseCD
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
  Resume ErrExit
End Sub

Public Property Get Minutos() As Integer
    
    Minutos = fMinuteValue(sGetPos)
End Property

Public Property Let Minutos(ByVal Valor As Integer)
    
    sSetPos Track, Valor, Segundos
End Property

Public Property Let Segundos(ByVal Valor As Integer)
    
    sSetPos Track, Minutos, Valor
End Property

Public Property Get Segundos() As Integer
    
    Segundos = fSecondValue(sGetPos)
End Property

Public Property Let Track(ByVal Valor As Integer)
    
    sSetPos Valor, Minutos, Segundos
End Property

Public Property Get Track() As Integer
    
    Track = fTrackValues(sGetPos)
End Property

Public Property Get AllTracks() As Collection
    
    On Error GoTo ErrHandle
    Set AllTracks = cTrackCollection
ErrExit:
    Exit Property
ErrHandle:
MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Property

Public Sub CloseCD()
    
    Dim mciGenParams  As MCI_GENERIC_PARMS
    Dim lRes          As Long
    On Error GoTo ErrHandle
    If mciOpenParameter.wDeviceID <> 0 Then
        StopTrack
        lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_CLOSE, MCI_WAIT, mciGenParams)
        mciOpenParameter.wDeviceID = 0
    End If
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Sub

Public Sub Eject()
    
    Dim sErrDescription As String
    Dim mciSetParam     As MCI_SET_PARMS
    Dim lFlags          As Long
    Dim lRes            As Long
    On Error GoTo ErrHandle

    lFlags = MCI_SET_DOOR_OPEN
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_SET, lFlags, mciSetParam)
  
    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error: " & Err.Number & ". " & Err.Description
  Resume ErrExit
End Sub

Public Sub OpenCD()
    
    Dim lRes As Long
    Dim sErrDescription As String
    Const sDevName As String = "cdaudio"
    Dim mciSetParam As MCI_SET_PARMS
    On Error GoTo ErrHandle

    If mciOpenParameter.wDeviceID <> 0 Then
        CloseCD
    End If
    
    mciOpenParameter.lpstrDeviceType = sDevName
    lRes = mciSendCommand(0, MCI_OPEN, MCI_WAIT Or _
            MCI_OPEN_SHAREABLE Or _
            MCI_OPEN_TYPE, mciOpenParameter)
  
    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
  
    mciSetParam.dwTimeFormat = MCI_FORMAT_TMSF

    lRes = mciSendCommand(mciOpenParameter.wDeviceID, _
            MCI_SET, MCI_WAIT Or _
            MCI_SET_TIME_FORMAT, _
            mciSetParam)
  
    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
    EnumerarTracks
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Sub

Public Sub Pausa()
    
    Dim lRes As Long
    On Error GoTo ErrHandle
    
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, _
    MCI_PAUSE, MCI_WAIT, 0)
    blPlay = False
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Sub

Public Sub Play()
    
    Dim lRes As Long
    Dim sErrDescription As String
    Dim mciPlay As MCI_PLAY_PARMS
    On Error GoTo ErrHandle
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_PLAY, _
            MCI_NOTIFY, mciPlay)
    
    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
  
    blPlay = True
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Sub

Public Sub StopTrack()
    
    Dim lRes As Long
    On Error GoTo ErrHandle
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_STOP, _
            MCI_WAIT, 0)
    blPlay = False
    sSetPos 1, 0, 0
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
  Resume ErrExit
End Sub

Private Function fConvertDoubleToLongVal(ByVal dValue As Double) _
                                                        As Long
    
    Dim dTmp        As Double
    Dim dDiv        As Double

    On Error GoTo ErrHandle
    dDiv = &H7FFFFFFF
    dDiv = (dDiv * 2) + 2

    If dValue > dDiv Or dValue < 0 Then
        dTmp = dValue - (Int(dValue / dDiv) * dDiv)
    Else
        dTmp = dValue
    End If
  
    If dTmp > &H7FFFFFFF Then
        fConvertDoubleToLongVal = dTmp - dDiv
        ElseIf dTmp < 0 Then
            fConvertDoubleToLongVal = dDiv + dTmp
        Else
            fConvertDoubleToLongVal = dTmp
    End If
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
  Resume ErrExit
End Function

Private Sub EnumerarTracks()
    Dim lFlags          As Long
    Dim sErrDescription As String
    Dim lRes            As Long
    Dim iCount          As Integer
    Dim iCountTrack     As Integer
    Dim mciSP           As MCI_STATUS_PARMS
    Dim mciSetParam     As MCI_SET_PARMS

    On Error GoTo ErrHandle
    mciSetParam.dwTimeFormat = MCI_FORMAT_TMSF
    lFlags = MCI_SET_TIME_FORMAT
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_SET, _
            lFlags, mciSetParam)
  
    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
    
    lFlags = MCI_STATUS_ITEM
    mciSP.dwItem = MCI_TRACK_NUMBERSTATE
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_STATUS, _
        lFlags, mciSP)

    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
  
    iCountTrack = mciSP.dwReturn
    Set cTrackCollection = New Collection
    For iCount = 0 To iCountTrack - 1
        mciSP.dwItem = MCI_STATUS_LENGTH
        mciSP.dwTrack = iCount + 1
        mciSendCommand mciOpenParameter.wDeviceID, MCI_STATUS, _
                MCI_TRACK Or _
                MCI_STATUS_ITEM, _
            mciSP
        cTrackCollection.Add (60 * (((mciSP.dwReturn And &H7FFF)) _
                And 255)) + _
                (((mciSP.dwReturn And &H7FFF) / 256) And 255)
    Next iCount
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
  Resume ErrExit
End Sub

Private Function sGetPos() As Long
    
    Dim mciSP As MCI_STATUS_PARMS
    Dim mciSetParam As MCI_SET_PARMS
    Dim lFlags As Long
    Dim lRes As Long
    Dim sErrDescription As String

    On Error GoTo ErrHandle

    mciSetParam.dwTimeFormat = MCI_FORMAT_TMSF
    lFlags = MCI_SET_TIME_FORMAT
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_SET, _
            lFlags, mciSetParam)
  
    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
  
    lFlags = MCI_STATUS_ITEM
    mciSP.dwItem = MCI_STATUS_POSITION
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_STATUS, _
            lFlags, mciSP)

    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
    sGetPos = mciSP.dwReturn
ErrExit:
    Exit Function
ErrHandle:
    Resume ErrExit
End Function

Private Function fConvertIntegerToByte(ByVal intVal As Integer) _
                                                        As Byte
    
    On Error GoTo ErrHandle
    fConvertIntegerToByte = intVal And &HFF&
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Function fConvertIntegerToLong(ByVal intVal As Integer) _
                                                        As Long
    
    On Error GoTo ErrHandle
    If intVal < 0 Then
        fConvertIntegerToLong = intVal + &H10000
    Else
        fConvertIntegerToLong = intVal
    End If
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Function fConvertLongToDouble(ByVal clNumber As Long) _
                                                    As Double
    
    
    Dim dDiv As Double
  
    On Error GoTo ErrHandle
    dDiv = &H7FFFFFFF
    dDiv = (dDiv * 2) + 2
  
    If clNumber < 0 Then
        fConvertLongToDouble = clNumber + dDiv
    Else
        fConvertLongToDouble = clNumber
    End If
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Function fLongToInteger(ByVal clNumber As Long) As Integer
    
    On Error GoTo ErrHandle

    clNumber = clNumber And &HFFFF&
    If clNumber > &H7FFF Then
        fLongToInteger = clNumber - &H10000
    Else
        fLongToInteger = clNumber
    End If
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Function fTimeValues(itvTrack As Integer, _
                             itvMinutes As Integer, _
                             itvSeconds As Integer) _
                             As Long

    On Error GoTo ErrHandle
    fTimeValues = CLng(itvTrack) Or CLng(fInt(itvMinutes, 8)) _
            Or CLng(fLng(itvSeconds, 16))

ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Function fMinuteValue(ltvTimeVal As Long) As Byte
    On Error GoTo ErrHandle
    fMinuteValue = fConvertIntegerToByte(fConvI(fLongToInteger(ltvTimeVal), 8))
ErrExit:
  Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Function fSecondValue(ltvTimeVal As Long) As Byte
    On Error GoTo ErrHandle
    fSecondValue = fConvertIntegerToByte(fLongToInteger(fConvL(ltvTimeVal, 16)))
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Function fTrackValues(ltvTimeVal As Long) As Byte
    On Error GoTo ErrHandle
    fTrackValues = fConvertIntegerToByte(fLongToInteger(ltvTimeVal))
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Sub sSetPos(itvTrack As Integer, itvMinutes As Integer, _
                                          itvSeconds As Integer)
  
    Dim lFlags            As Long
    Dim lRes              As Long
    Dim sErrDescription   As String
    Dim mciPlay           As MCI_PLAY_PARMS
    Dim mciSetParam       As MCI_SET_PARMS

    On Error GoTo ErrHandle
  
    mciSetParam.dwTimeFormat = MCI_FORMAT_TMSF
    lFlags = MCI_SET_TIME_FORMAT
    lRes = mciSendCommand(mciOpenParameter.wDeviceID, MCI_SET, _
            lFlags, mciSetParam)
  
    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
    lFlags = MCI_TO Or MCI_WAIT
  
    If (blPlay) Then
        mciPlay.dwFrom = fTimeValues(itvTrack, itvMinutes, itvSeconds)
        lRes = mciSendCommand(mciOpenParameter.wDeviceID, _
            MCI_PLAY, MCI_FROM, mciPlay)
    Else
        mciPlay.dwTo = fTimeValues(itvTrack, itvMinutes, itvSeconds)
        mciPlay.dwFrom = fTimeValues(itvTrack, itvMinutes, itvSeconds)
        lRes = mciSendCommand(mciOpenParameter.wDeviceID, _
            MCI_PLAY, MCI_FROM Or _
            MCI_TO, mciPlay)
    End If
    If lRes <> 0 Then
        sErrDescription = Space$(iLenErrString)
        mciGetErrorString lRes, sErrDescription, iLenErrString
        Err.Raise lRes, , sErrDescription
    End If
ErrExit:
    Exit Sub
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Sub

Private Function fInt(ByVal Valor As Integer, ByVal btPos As Byte) _
                                                        As Integer
  Dim lMultipli As Long
  On Error GoTo ErrHandle
  
  If btPos >= 16 Then
    fInt = 0
  Else
    lMultipli = 2 ^ btPos
    fInt = fLongToInteger(Valor * lMultipli)
  End If
  
ErrExit:
  Exit Function

ErrHandle:
  MsgBox "Error : " & Err.Number & ". " & Err.Description
  Resume ErrExit

End Function

Private Function fLng(ByVal clNumber As Long, ByVal btPos As Byte) As Long
    Dim dbMultipli As Double
    On Error GoTo ErrHandle
  
    If btPos >= 32 Then
        fLng = 0
    Else
        dbMultipli = 2 ^ btPos
        fLng = fConvertDoubleToLongVal(clNumber * dbMultipli)
    End If
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description
    Resume ErrExit
End Function

Private Function fConvI(ByVal lngValue As Long, ByVal btPos As Byte) As Integer
    Dim lDiv As Long
    On Error GoTo ErrHandle
  
    If btPos >= 16 Then
        fConvI = 0
    Else
        lDiv = 2 ^ btPos
        fConvI = Int(fConvertIntegerToLong(lngValue) / lDiv)
    End If
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description, , _
        "Error..."
    Resume ErrExit
End Function

Private Function fConvL(ByVal clNumber As Long, ByVal btPos As Byte) As Long
    Dim lDiv As Long
    On Error GoTo ErrHandle
  
    If btPos >= 32 Then
        fConvL = 0
    Else
        lDiv = 2 ^ btPos
        fConvL = Int(fConvertLongToDouble(clNumber) / lDiv)
    End If
ErrExit:
    Exit Function
ErrHandle:
    MsgBox "Error : " & Err.Number & ". " & Err.Description, , _
        "Error..."
    Resume ErrExit
End Function


